## zeal 0.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.3)

# CMake options.
set(CMAKE_ERROR_DEPRECATED TRUE)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

project(Zeal
    VERSION 0.7.0
    DESCRIPTION "A simple documentation browser."
    HOMEPAGE_URL "https://zealdocs.org"
    LANGUAGES CXX
)

# Set to TRUE for a tagged release.
# NOTE: Don't forget to add a new release entry in the AppStream metadata!
if(NOT ZEAL_RELEASE_BUILD AND DEFINED ENV{ZEAL_RELEASE_BUILD})
    set(ZEAL_RELEASE_BUILD $ENV{ZEAL_RELEASE_BUILD})
endif()

# Project information.
set(PROJECT_COMPANY_NAME "Oleg Shparber")
set(PROJECT_COPYRIGHT "© 2013-2023 Oleg Shparber and other contributors")

# Find available major Qt version. It will be stored in QT_VERSION_MAJOR.
find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
if(QT_VERSION_MAJOR EQUAL 6)
    set(QT_MINIMUM_VERSION 6.2.0)
else()
    set(QT_MINIMUM_VERSION 5.9.5)
endif()

# Determine version for dev builds.
if(NOT ZEAL_RELEASE_BUILD)
    message(NOTICE "Building unreleased code. Proceed at your own risk!")

    # TODO: Add support for metadata passed from env, e.g. aur, appimage, etc.
    include(GetVersionFromGit)
    if(Zeal_GIT_VERSION_SHA)
        # Extra check in case we forgot to bump version in project() directive.
        if(NOT PROJECT_VERSION_PATCH EQUAL Zeal_GIT_VERSION_PATCH_NEXT)
            message(WARNING "Incorrect patch version! Forgot to bump?")
        endif()

        set(ZEAL_VERSION_SUFFIX "-dev.${Zeal_GIT_VERSION_AHEAD}+${Zeal_GIT_VERSION_SHA}")
    else()
        set(ZEAL_VERSION_SUFFIX "-dev")
    endif()
endif()

set(ZEAL_VERSION_FULL "${Zeal_VERSION}${ZEAL_VERSION_SUFFIX}")
message(NOTICE "Calculated Zeal version: ${ZEAL_VERSION_FULL}")

file(WRITE "${CMAKE_BINARY_DIR}/zeal_version" ${ZEAL_VERSION_FULL})

# A custom target to print the full version.
# Usage: cmake --build build --preset ninja-multi-vcpkg-release --target zeal_version
add_custom_target(zeal_version
    COMMAND ${CMAKE_COMMAND} -E echo "Zeal version: ${ZEAL_VERSION_FULL}"
    VERBATIM
)

if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.24.0")
    set(CMAKE_COMPILE_WARNING_AS_ERROR ON)
endif()

add_subdirectory(assets)
add_subdirectory(src)

=== src/app/CMakeLists.txt ===
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets REQUIRED)
if (Qt${QT_VERSION_MAJOR}Widgets_VERSION VERSION_LESS QT_MINIMUM_VERSION)
    message(FATAL_ERROR "Qt version >= ${QT_MINIMUM_VERSION} is required.")
endif()

# Define output binary name.
if(APPLE)
    set(_project_output_name ${CMAKE_PROJECT_NAME})
else()
    string(TOLOWER ${CMAKE_PROJECT_NAME} _project_output_name)
endif()

set(PROJECT_EXECUTABLE_NAME "${_project_output_name}${CMAKE_EXECUTABLE_SUFFIX}")
message(STATUS "Project executable name: ${PROJECT_EXECUTABLE_NAME}")

# Only support installing runtime dependencies with Qt >=6.5.1 (see QTBUG-111741).
if(Qt${QT_VERSION_MAJOR}Widgets_VERSION VERSION_GREATER_EQUAL "6.5.1")
    set(_use_qt_cmake_commands TRUE)

    qt_standard_project_setup()
endif()

if(APPLE)
    list(APPEND App_RESOURCES resources/zeal.icns)
elseif(WIN32)
    configure_file(versioninfo.rc.in ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.rc)
    list(APPEND App_RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.rc)
else()
    set(App_RESOURCES) # Silence CMake warning.
endif()

if(QT_VERSION_MAJOR EQUAL 6)
    qt_add_executable(App WIN32
        main.cpp
        zeal.qrc
        ${App_RESOURCES}
    )
else()
    add_executable(App WIN32
        main.cpp
        zeal.qrc
        ${App_RESOURCES}
    )
endif()

target_link_libraries(App PRIVATE Core Util Qt${QT_VERSION_MAJOR}::Widgets)

set_target_properties(App PROPERTIES
    OUTPUT_NAME ${_project_output_name}
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)

# Install Qt runtime dependencies on Windows.
if(WIN32 AND _use_qt_cmake_commands)
    qt_generate_deploy_script(
        TARGET App
        OUTPUT_SCRIPT _qt_deploy_script
        CONTENT "
# TODO: Run windeployqt after build.
# Override deployment script's working directory.
# set(QT_DEPLOY_PREFIX \"$<TARGET_FILE_DIR:App>\")

qt_deploy_runtime_dependencies(
    EXECUTABLE \"$<TARGET_FILE:App>\"
    BIN_DIR .
    NO_TRANSLATIONS
    NO_COMPILER_RUNTIME
)")
endif()

if(APPLE)
    set_target_properties(App PROPERTIES
        MACOSX_BUNDLE TRUE
        MACOSX_BUNDLE_BUNDLE_NAME ${CMAKE_PROJECT_NAME}
        MACOSX_BUNDLE_GUI_IDENTIFIER "org.zealdocs.zeal"
        MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
        MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION}
        MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
        MACOSX_BUNDLE_ICON_FILE "zeal.icns"
        MACOSX_BUNDLE_COPYRIGHT ${PROJECT_COPYRIGHT}
        RESOURCE "resources/zeal.icns"
    )
elseif(WIN32)
    install(TARGETS App RUNTIME DESTINATION .)

    if(_use_qt_cmake_commands)
        # Install Qt runtime dependencies.
        install(SCRIPT ${_qt_deploy_script})

        unset(_qt_deploy_script)
        unset(_use_qt_cmake_commands)
    endif()
elseif(UNIX)
    include(GNUInstallDirs)
    install(TARGETS App DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

#
# CPack configuration.
#
set(CPACK_GENERATOR "7Z;ZIP")

set(CPACK_VERBATIM_VARIABLES YES)

# Usage: cmake --build --preset <preset-name> --target package
# E.g. cmake --build build --preset ninja-multi-vcpkg-release --target package
set(CPACK_PACKAGE_NAME ${CMAKE_PROJECT_NAME})
set(CPACK_PACKAGE_DESCRIPTION ${CMAKE_PROJECT_DESCRIPTION})
set(CPACK_PACKAGE_VENDOR ${PROJECT_COMPANY_NAME})
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/src/app/resources/zeal.ico")

# Set binary package file name.
if(WIN32)
    if(CMAKE_SYSTEM_PROCESSOR STREQUAL "AMD64")
        set(_package_file_name_suffix "-windows-x64")
    elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "IA64")
        set(_package_file_name_suffix "-windows-x64")
    elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "X86")
        set(_package_file_name_suffix "-windows-x86")
    elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "ARM64")
        set(_package_file_name_suffix "-windows-arm64")
    else()
        set(_package_file_name_suffix "-windows-unknown")
    endif()
endif()

if(ZEAL_PORTABLE_BUILD)
    string(PREPEND _package_file_name_suffix "-portable")
endif()

set(CPACK_PACKAGE_FILE_NAME "${_project_output_name}-${ZEAL_VERSION_FULL}${_package_file_name_suffix}")

set(CPACK_PACKAGE_INSTALL_DIRECTORY ${CPACK_PACKAGE_NAME})
set(CPACK_PACKAGE_EXECUTABLES ${_project_output_name} ${CPACK_PACKAGE_NAME})
set(CPACK_CREATE_DESKTOP_LINKS ${_project_output_name} ${CPACK_PACKAGE_NAME})

# Allow CPack to do text to RTF conversion.
configure_file("${CMAKE_SOURCE_DIR}/COPYING" "${CMAKE_CURRENT_BINARY_DIR}/license.txt" COPYONLY)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_BINARY_DIR}/license.txt")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")

set(CPACK_PACKAGE_CHECKSUM SHA256)

if(WIN32)
    # CPack WiX configuration.
    set(CPACK_WIX_UPGRADE_GUID "5C4B6030-A1B4-4EFE-A5AF-28F6FA2E7978")
    set(CPACK_WIX_PROPERTY_ARPURLINFOABOUT ${CMAKE_PROJECT_HOMEPAGE_URL})
    set(CPACK_WIX_PRODUCT_ICON "${CMAKE_SOURCE_DIR}/src/app/resources/zeal.ico")
    #set(CPACK_WIX_UI_BANNER "${CMAKE_SOURCE_DIR}/pkg/wix/banner.png")
    #set(CPACK_WIX_UI_DIALOG "${CMAKE_SOURCE_DIR}/pkg/wix/dialog.png")
    set(CPACK_WIX_EXTENSIONS "WixUtilExtension.dll")
    set(CPACK_WIX_UI_REF "Zeal_InstallDir")
    set(CPACK_WIX_TEMPLATE "${CMAKE_SOURCE_DIR}/pkg/wix/template.xml")
    set(CPACK_WIX_PATCH_FILE "${CMAKE_SOURCE_DIR}/pkg/wix/patch.xml")
    set(CPACK_WIX_EXTRA_SOURCES
        "${CMAKE_SOURCE_DIR}/pkg/wix/ui.wxs"
        "${CMAKE_SOURCE_DIR}/pkg/wix/exitdialog.wxs"
    )

    set(CPACK_PRE_BUILD_SCRIPTS "${CMAKE_SOURCE_DIR}/pkg/wix/cpack_pre_build.cmake")

    if(NOT ZEAL_PORTABLE_BUILD)
        list(APPEND CPACK_GENERATOR "WIX")
        set(CPACK_POST_BUILD_SCRIPTS "${CMAKE_SOURCE_DIR}/pkg/wix/cpack_post_build.cmake")
    endif()
endif()

# Set options for the source package.
# Usage: cmake --build <build> --target package_source
set(CPACK_SOURCE_GENERATOR "TGZ;TXZ;ZIP")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${_project_output_name}-${ZEAL_VERSION_FULL}")
set(CPACK_SOURCE_IGNORE_FILES
    # Directories.
    ".git/"
    ".github/"
    ".vscode/"
    "build/"
    # Files.
    ".editorconfig"
    ".gitattributes"
    ".gitignore"
)

include(CPack)

=== src/libs/core/CMakeLists.txt ===
add_library(Core STATIC
    application.cpp
    applicationsingleton.cpp
    extractor.cpp
    filemanager.cpp
    httpserver.cpp
    networkaccessmanager.cpp
    settings.cpp

    # Show headers without .cpp in Qt Creator.
    httplib.h
)

# Configure cpp-httplib.
add_definitions(-DCPPHTTPLIB_USE_POLL)

target_link_libraries(Core Registry Ui)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Network WebEngineCore Widgets REQUIRED)
target_link_libraries(Core Qt${QT_VERSION_MAJOR}::Network Qt${QT_VERSION_MAJOR}::WebEngineCore Qt${QT_VERSION_MAJOR}::Widgets)

if(QT_VERSION_MAJOR EQUAL 6)
    find_package(Qt6 COMPONENTS WebEngineCore Widgets REQUIRED)
    target_link_libraries(Core Qt6::WebEngineCore)
else()
    find_package(Qt5 COMPONENTS WebEngine Widgets REQUIRED)
    target_link_libraries(Core Qt5::WebEngine)
endif()

find_package(LibArchive REQUIRED)

# Set LibArchive_INCLUDE_DIR on macOS when LibArchive is installed with Homebrew.
# See https://github.com/Homebrew/legacy-homebrew/issues/21415.
if(APPLE AND NOT LibArchive_INCLUDE_DIR)
  set(LibArchive_INCLUDE_DIR "/usr/local/opt/libarchive/include")
endif()

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.17.0)
    target_link_libraries(Core LibArchive::LibArchive)
else()
    include_directories(${LibArchive_INCLUDE_DIRS})
    target_link_libraries(Core ${LibArchive_LIBRARIES})
endif()

# Required by cpp-httplib.
if(NOT WIN32)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
    find_package(Threads REQUIRED)
    target_link_libraries(Core Threads::Threads)
endif()

=== src/libs/registry/CMakeLists.txt ===
add_library(Registry STATIC
    docset.cpp
    docsetmetadata.cpp
    docsetregistry.cpp
    listmodel.cpp
    searchmodel.cpp
    searchquery.cpp

    # Show headers without .cpp in Qt Creator.
    cancellationtoken.h
    itemdatarole.h
    searchresult.h
)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Concurrent Gui Network REQUIRED)
target_link_libraries(Registry Util Qt${QT_VERSION_MAJOR}::Concurrent Qt${QT_VERSION_MAJOR}::Gui Qt${QT_VERSION_MAJOR}::Network)

=== src/libs/ui/qxtglobalshortcut/CMakeLists.txt ===
list(APPEND QxtGlobalShortcut_SOURCES
    qxtglobalshortcut.cpp
)

if(APPLE)
    list(APPEND QxtGlobalShortcut_SOURCES
        qxtglobalshortcut_mac.cpp
    )
elseif(UNIX)
    find_package(X11)
    if(X11_FOUND)
        list(APPEND QxtGlobalShortcut_SOURCES
            qxtglobalshortcut_x11.cpp
        )
    endif()
elseif(WIN32)
    list(APPEND QxtGlobalShortcut_SOURCES
        qxtglobalshortcut_win.cpp
    )
endif()

add_library(QxtGlobalShortcut STATIC ${QxtGlobalShortcut_SOURCES})

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Gui REQUIRED)
target_link_libraries(QxtGlobalShortcut Qt${QT_VERSION_MAJOR}::Gui)

if(APPLE)
    find_library(CARBON_LIBRARY Carbon)
    target_link_libraries(QxtGlobalShortcut ${CARBON_LIBRARY})
elseif(UNIX AND X11_FOUND)
    target_link_libraries(QxtGlobalShortcut ${X11_LIBRARIES})

    if(QT_VERSION_MAJOR EQUAL 5)
        find_package(Qt5 COMPONENTS X11Extras REQUIRED)
        target_link_libraries(QxtGlobalShortcut Qt5::X11Extras)
    else()
        target_link_libraries(QxtGlobalShortcut Qt${QT_VERSION_MAJOR}::GuiPrivate)
    endif()

    find_package(ECM REQUIRED NO_MODULE)
    set(CMAKE_MODULE_PATH ${ECM_FIND_MODULE_DIR})

    find_package(XCB COMPONENTS XCB KEYSYMS REQUIRED)
    target_link_libraries(QxtGlobalShortcut XCB::XCB XCB::KEYSYMS)
endif()

=== src/libs/ui/widgets/CMakeLists.txt ===
add_library(Widgets STATIC
    layouthelper.cpp
    searchedit.cpp
    shortcutedit.cpp
    toolbarframe.cpp
)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets REQUIRED)
target_link_libraries(Widgets Qt${QT_VERSION_MAJOR}::Widgets)

=== debian/changelog ===
zeal (1:0.7.0-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:40:57 +1100

zeal (1:0.7.0-3build1) noble; urgency=medium

  * No-change rebuild against libarchive13t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Mar 2024 07:25:14 +0000

zeal (1:0.7.0-3) unstable; urgency=medium

  * Reinstate the Qt5 build-deps for mips64el and mipsel. I'd prefer
    to have every architectures with the same version of Qt, but it's
    better to have an old lib than no package at all.

 -- Martin Quinson <mquinson@debian.org>  Sun, 01 Oct 2023 10:53:07 +0200

zeal (1:0.7.0-2) unstable; urgency=medium

  * Restrict the Architectures to where qtwebengine6 is available.
  * d/p/reproducible-build.patch: Remove a timestamp from a generated
    svg file (Close: #1015246). Thanks Chris Lamb.
  * Fix the manpage by removing a command line option that does not
    exist anymore (Close: #1033168).

 -- Martin Quinson <mquinson@debian.org>  Sat, 30 Sep 2023 22:40:10 +0200

zeal (1:0.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Switch to Qt6 now that upstream provides it.
  * Remove the restriction on Architectures now that we don't use
    qtwebengine5 anymore.

 -- Martin Quinson <mquinson@debian.org>  Fri, 29 Sep 2023 10:59:33 +0200

=== debian/control ===
Source: zeal
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Uploaders: Martin Quinson <mquinson@debian.org>
Section: doc
Priority: optional
Build-Depends: debhelper-compat (= 13),
               asciidoc-base,
               cmake,
               extra-cmake-modules,
               libarchive-dev,
               libcpp-httplib-dev,
               libsqlite3-dev,
               libxcb-keysyms1-dev,
               qt6-base-dev [amd64 arm64 armhf i386],
               qt6-base-private-dev [amd64 arm64 armhf i386],
	       qt6-webchannel-dev [amd64 arm64 armhf i386],
	       qt6-webengine-dev [amd64 arm64 armhf i386],
	       libqt5webkit5-dev [mips64el mipsel],
	       libqt5x11extras5-dev [mips64el mipsel],
	       qtbase5-dev [mips64el mipsel],
	       qtbase5-private-dev [mips64el mipsel],
	       qtwebengine5-dev [mips64el mipsel],
	       xmlto,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/zeal
Vcs-Git: https://salsa.debian.org/debian/zeal.git
Homepage: https://zealdocs.org/

Package: zeal
Architecture: amd64 arm64 armhf i386 mips64el mipsel
# qt6-webengine is available only on amd64 arm64 armhf i386
# qtwebengine5-dev is available on the same + mips64el mipsel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libqt5sql5-sqlite
Description: Simple offline API documentation browser
 Zeal is a simple offline API documentation browser inspired by Dash (OS X
 app), available for Linux and Windows.
 .
  * Quickly search documentation using Alt+Space (or customised) hotkey to
    display Zeal from any place in your workspace.
  * Search in multiple sets of documentation at once.
  * Don't be dependent on your internet connection.
  * Integrate Zeal with Emacs, Sublime Text, or Vim.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export QT_SELECT := qt6

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@

execute_before_dh_auto_configure:
	cat debian/*manpages | sed 's/$$/.txt/p' | xargs -n 1 a2x --doctype manpage --format manpage

## zeal 0.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
 project(Zeal
-    VERSION 0.7.0
+    VERSION 0.7.1
     DESCRIPTION "A simple documentation browser."
     HOMEPAGE_URL "https://zealdocs.org"
     LANGUAGES CXX

=== src/libs/CMakeLists.txt ===
add_subdirectory(browser)
add_subdirectory(core)
add_subdirectory(registry)
add_subdirectory(sidebar)
add_subdirectory(ui)
add_subdirectory(util)

=== src/libs/core/CMakeLists.txt ===
--- 
+++ 
@@ -27,15 +27,21 @@
     target_link_libraries(Core Qt5::WebEngine)
 endif()
 
-find_package(LibArchive REQUIRED)
-
-# Set LibArchive_INCLUDE_DIR on macOS when LibArchive is installed with Homebrew.
-# See https://github.com/Homebrew/legacy-homebrew/issues/21415.
-if(APPLE AND NOT LibArchive_INCLUDE_DIR)
-  set(LibArchive_INCLUDE_DIR "/usr/local/opt/libarchive/include")
+find_package(LibArchive QUIET)
+if(NOT LibArchive_FOUND)
+    find_path(LibArchive_INCLUDE_DIRS archive.h
+        PATHS /opt/homebrew/opt/libarchive/include /usr/local/opt/libarchive/include
+        REQUIRED
+    )
+    find_library(LibArchive_LIBRARIES
+        NAMES archive libarchive
+        PATHS /opt/homebrew/opt/libarchive/lib /usr/local/opt/libarchive/lib
+        REQUIRED
+        NO_DEFAULT_PATH
+    )
 endif()
 
-if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.17.0)
+if((CMAKE_VERSION VERSION_GREATER_EQUAL 3.17.0) AND (TARGET LibArchive::LibArchive))
     target_link_libraries(Core LibArchive::LibArchive)
 else()
     include_directories(${LibArchive_INCLUDE_DIRS})

=== debian/changelog ===
zeal (1:0.7.1-1) unstable; urgency=medium

  * New upstream release.

 -- Martin Quinson <mquinson@debian.org>  Thu, 01 Aug 2024 21:30:34 +0200

zeal (1:0.7.0-4) unstable; urgency=medium

  * Take a patch upstream to fix a FTBFS with Qt 6.2.2, which will be
    uploaded to unstable soon.

 -- Martin Quinson <mquinson@debian.org>  Mon, 11 Mar 2024 11:55:21 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: zeal
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
+Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
 Uploaders: Martin Quinson <mquinson@debian.org>
 Section: doc
 Priority: optional

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,8 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk
 
+export ZEAL_RELEASE_BUILD = 1
+
 %:
 	dh $@

## zeal 0.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
 project(Zeal
-    VERSION 0.7.1
+    VERSION 0.7.2
     DESCRIPTION "A simple documentation browser."
     HOMEPAGE_URL "https://zealdocs.org"
     LANGUAGES CXX
@@ -19,15 +19,20 @@
 
 # Project information.
 set(PROJECT_COMPANY_NAME "Oleg Shparber")
-set(PROJECT_COPYRIGHT "© 2013-2023 Oleg Shparber and other contributors")
+set(PROJECT_COPYRIGHT "© 2013-2024 Oleg Shparber and other contributors")
 
 # Find available major Qt version. It will be stored in QT_VERSION_MAJOR.
-find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
-if(QT_VERSION_MAJOR EQUAL 6)
+if(NOT ZEAL_USE_QT5)
+    find_package(QT NAMES Qt6 COMPONENTS Core)
     set(QT_MINIMUM_VERSION 6.2.0)
-else()
+endif()
+
+if(NOT QT_FOUND)
+    find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core)
     set(QT_MINIMUM_VERSION 5.9.5)
 endif()
+
+message(NOTICE "Detected Qt version: ${QT_VERSION}")
 
 # Determine version for dev builds.
 if(NOT ZEAL_RELEASE_BUILD)

=== assets/CMakeLists.txt ===
add_subdirectory(freedesktop)

=== assets/freedesktop/CMakeLists.txt ===
if(UNIX AND NOT APPLE)
    find_package(ECM 1.0.0 REQUIRED NO_MODULE)
    set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
    include(ECMInstallIcons)

    if(QT_VERSION_MAJOR EQUAL 5)
        include(KDEInstallDirs)
    else()
        # Workaround until KDEInstallDirs6 is ready to use.
        include(GNUInstallDirs)
        set(KDE_INSTALL_APPDIR "${CMAKE_INSTALL_DATAROOTDIR}/applications")
        set(KDE_INSTALL_ICONDIR "${CMAKE_INSTALL_DATAROOTDIR}/icons")
        set(KDE_INSTALL_METAINFODIR "${CMAKE_INSTALL_DATAROOTDIR}/metainfo")
    endif()

    ecm_install_icons(ICONS "16-apps-zeal.png"
                            "24-apps-zeal.png"
                            "32-apps-zeal.png"
                            "64-apps-zeal.png"
                            "128-apps-zeal.png"
                      DESTINATION ${KDE_INSTALL_ICONDIR}
    )

# For development builds insert an extra release in the AppStream metadata.
if(NOT ZEAL_RELEASE_BUILD)
    string(TIMESTAMP ZEAL_APPSTREAM_DEV_RELEASE "\n    <release date=\"%Y-%m-%d\" version=\"${ZEAL_VERSION_FULL}\" type=\"development\" />")
endif()

    configure_file(
        org.zealdocs.zeal.appdata.xml.in
        org.zealdocs.zeal.appdata.xml
    )

    install(FILES ${CMAKE_BINARY_DIR}/assets/freedesktop/org.zealdocs.zeal.appdata.xml
            DESTINATION ${KDE_INSTALL_METAINFODIR}
    )

    install(FILES "org.zealdocs.zeal.desktop"
            DESTINATION ${KDE_INSTALL_APPDIR}
    )
endif()

=== src/app/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets REQUIRED)
+find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Concurrent WebEngineWidgets Widgets REQUIRED)
 if (Qt${QT_VERSION_MAJOR}Widgets_VERSION VERSION_LESS QT_MINIMUM_VERSION)
     message(FATAL_ERROR "Qt version >= ${QT_MINIMUM_VERSION} is required.")
 endif()
@@ -123,6 +123,8 @@
     else()
         set(_package_file_name_suffix "-windows-unknown")
     endif()
+else()
+    set(_package_file_name_suffix "")
 endif()
 
 if(ZEAL_PORTABLE_BUILD)

=== src/libs/browser/CMakeLists.txt ===
add_library(Browser STATIC
    searchtoolbar.cpp
    settings.cpp
    urlrequestinterceptor.cpp
    webbridge.cpp
    webcontrol.cpp
    webpage.cpp
    webview.cpp
)

target_link_libraries(Browser)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS WebChannel WebEngineWidgets REQUIRED)
target_link_libraries(Browser Qt${QT_VERSION_MAJOR}::WebChannel Qt${QT_VERSION_MAJOR}::WebEngineWidgets)

=== src/libs/core/CMakeLists.txt ===
--- 
+++ 
@@ -6,13 +6,7 @@
     httpserver.cpp
     networkaccessmanager.cpp
     settings.cpp
-
-    # Show headers without .cpp in Qt Creator.
-    httplib.h
 )
-
-# Configure cpp-httplib.
-add_definitions(-DCPPHTTPLIB_USE_POLL)
 
 target_link_libraries(Core Registry Ui)
 
@@ -48,6 +42,18 @@
     target_link_libraries(Core ${LibArchive_LIBRARIES})
 endif()
 
+# Configure cpp-httplib.
+add_definitions(-DCPPHTTPLIB_USE_POLL)
+
+find_package(httplib CONFIG QUIET)
+if(httplib_FOUND)
+    target_link_libraries(Core httplib::httplib)
+else()
+    # Use bundled version of cpp-httplib if not found.
+    # TODO: Replace with QHttpServer once Qt 5 is dropped.
+    include_directories("${CMAKE_SOURCE_DIR}/src/contrib/cpp-httplib")
+endif()
+
 # Required by cpp-httplib.
 if(NOT WIN32)
     set(THREADS_PREFER_PTHREAD_FLAG ON)

=== src/libs/sidebar/CMakeLists.txt ===
add_library(Sidebar STATIC
    container.cpp
    proxyview.cpp
    view.cpp
    viewprovider.cpp
)

target_link_libraries(Sidebar)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets REQUIRED)
target_link_libraries(Sidebar Qt${QT_VERSION_MAJOR}::Widgets)

=== src/libs/ui/CMakeLists.txt ===
add_subdirectory(qxtglobalshortcut)
add_subdirectory(widgets)

set(Ui_FORMS
    aboutdialog.ui
    docsetsdialog.ui
    mainwindow.ui
    settingsdialog.ui
)

add_library(Ui STATIC
    aboutdialog.cpp
    browsertab.cpp
    docsetlistitemdelegate.cpp
    docsetsdialog.cpp
    mainwindow.cpp
    searchitemdelegate.cpp
    searchsidebar.cpp
    settingsdialog.cpp
    sidebarviewprovider.cpp
    ${Ui_FORMS} # For Qt Creator.
)

target_link_libraries(Ui Browser Sidebar QxtGlobalShortcut Widgets Registry)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS WebEngineWidgets REQUIRED)
target_link_libraries(Ui Qt${QT_VERSION_MAJOR}::WebEngineWidgets)

=== src/libs/util/CMakeLists.txt ===
# Nothing to moc here, so avoid empty build units.
set(CMAKE_AUTOMOC OFF)

add_library(Util STATIC
    plist.cpp
    sqlitedatabase.cpp

    # Show headers without .cpp in Qt Creator.
    caseinsensitivemap.h
)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core REQUIRED)
target_link_libraries(Util Qt${QT_VERSION_MAJOR}::Core)

find_package(SQLite3 REQUIRED)
target_link_libraries(Util SQLite::SQLite3)

# TODO: Do not export SQLite headers.
target_include_directories(Util PUBLIC ${SQLite3_INCLUDE_DIRS})

=== src/libs/ui/qxtglobalshortcut/CMakeLists.txt ===
--- 
+++ 
@@ -12,10 +12,18 @@
         list(APPEND QxtGlobalShortcut_SOURCES
             qxtglobalshortcut_x11.cpp
         )
+    else()
+        list(APPEND QxtGlobalShortcut_SOURCES
+            qxtglobalshortcut_noop.cpp
+        )
     endif()
 elseif(WIN32)
     list(APPEND QxtGlobalShortcut_SOURCES
         qxtglobalshortcut_win.cpp
+    )
+else()
+    list(APPEND QxtGlobalShortcut_SOURCES
+        qxtglobalshortcut_noop.cpp
     )
 endif()

=== debian/changelog ===
zeal (1:0.7.2-1.1build1) questing; urgency=medium

  * No-change rebuild for Qt 6.9.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Tue, 16 Sep 2025 21:39:05 +0100

zeal (1:0.7.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop Build-Depends: libqt5webkit5-dev. (Closes: #1100770)
  * Drop mipsel from build architectures.
  * Recover uploaded 0.7.1-1 changelog entry.

 -- Bastian Germann <bage@debian.org>  Tue, 18 Mar 2025 16:51:03 +0100

zeal (1:0.7.2-1) unstable; urgency=medium

  [ Konstantin Demin ]
  * New upstream release.

 -- Martin Quinson <mquinson@debian.org>  Mon, 23 Dec 2024 11:10:33 +0100

=== debian/control ===
Source: zeal
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Uploaders: Martin Quinson <mquinson@debian.org>
Section: doc
Priority: optional
Build-Depends: debhelper-compat (= 13),
               asciidoc-base,
               cmake,
               extra-cmake-modules,
               libarchive-dev,
               libcpp-httplib-dev,
               libsqlite3-dev,
               libxcb-keysyms1-dev,
               qt6-base-dev [amd64 arm64 armhf i386],
               qt6-base-private-dev [amd64 arm64 armhf i386],
               qt6-webchannel-dev [amd64 arm64 armhf i386],
               qt6-webengine-dev [amd64 arm64 armhf i386],
               libqt5x11extras5-dev [mips64el],
               qtbase5-dev [mips64el],
               qtbase5-private-dev [mips64el],
               qtwebengine5-dev [mips64el],
               xmlto,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/zeal
Vcs-Git: https://salsa.debian.org/debian/zeal.git
Homepage: https://zealdocs.org/

Package: zeal
Architecture: amd64 arm64 armhf i386 mips64el
# qt6-webengine is available only on amd64 arm64 armhf i386
# qtwebengine5-dev is available on the same + mips64el
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libqt6sql6-sqlite [amd64 arm64 armhf i386],
         libqt5sql5-sqlite [mips64el],
Description: Simple offline API documentation browser
 Zeal is a simple offline API documentation browser inspired by Dash (OS X
 app), available for Linux and Windows.
 .
  * Quickly search documentation using Alt+Space (or customised) hotkey to
    display Zeal from any place in your workspace.
  * Search in multiple sets of documentation at once.
  * Don't be dependent on your internet connection.
  * Integrate Zeal with Emacs, Sublime Text, or Vim.

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,13 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS := hardening=+all
-export QT_SELECT := qt6
+
+qt6_arch := amd64 arm64 armhf i386
+ifneq ($(filter $(DEB_TARGET_ARCH),$(strip $(qt6_arch))),)
+  export QT_SELECT := qt6
+else
+  export QT_SELECT := qt5
+endif
 
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk
